/**
 * 
 */
package org.lantsovanton.abstraction.model.impl;

import org.lantsovanton.GameException;
import org.lantsovanton.abstraction.model.*;

import java.util.*;

/**
 * @author 
 *
 */
public class RandomIntellect implements Intellect {
	 private IGame myGame;
	 private int myPlayer;
	 private IPosition myPosition;
	 private String myName = "Random000";
	 private boolean myPermit;
	 
	 public RandomIntellect(){ 		 
		 myPermit = true;
	 }
	 
	 public RandomIntellect( IGame game, int player, IPosition position ){
		 myGame = game;
		 myPlayer = player;
		 myPosition = position;
	 }

	/** 
	 * @see org.lantsovanton.abstraction.model.Intellect#getGame()
	 */
	public IGame getGame() {
		return myGame;
	}

	/* (non-Javadoc)
	 * @see org.lantsovanton.intellect.Intellect#getPlayer()
	 */
	public int getPlayer() {		
		return myPlayer;
	}

	/* (non-Javadoc)
	 * @see org.lantsovanton.intellect.Intellect#getPosition()
	 */
	public IPosition getPosition() {		
		return myPosition;
	}

	/* (non-Javadoc)
	 * @see org.lantsovanton.intellect.Intellect#go()
	 */
	public IMove go() {
		Random random = new Random(); 
		if( myPosition.getPlayer() != myPlayer || myGame.isGameFinish( myPosition ) ){
			throw new GameException();
		}
		if( myPermit ){
			while( true ){
				int h = random.nextInt( myPosition.getHight() );
				int l = random.nextInt( myPosition.getWidth() );
				IMove move = new Move( h, l, myPlayer );
				if( myGame.isMovePosible( myPosition, move ) ){
					return move;
				}
			}	
		}else{
			for( int h=0; h < myPosition.getHight(); h++  ){
				for( int l = 0; l < myPosition.getWidth(); l++ ){
					IMove move = new Move( h, l, myPlayer );
					if( myGame.isMovePosible( myPosition, move ) ){
						return move;
					}
				}
			}	
		}
		return null;	
		
	}

	public String getName() {
		return myName;
	}

	public void setGame(IGame game) {
		myGame = game;
		
	}

	public void setPosition(IPosition position) {
		myPosition = position;
		
	}

	public void setPlayer(int player) {
		myPlayer = player;
		
	}

	public void setRandom(boolean permit) {
		myPermit = permit;
		
	}

}
