package org.lantsovanton.games;


import java.io.File;


import java.io.IOException;

import java.net.URL;
import java.net.URLDecoder;

import java.util.Enumeration;
import java.util.LinkedList;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

import org.lantsovanton.abstraction.model.IGame;



public class GameLoader extends ClassLoader {
	private static LinkedList<String> myName = new LinkedList<String>();
	private String myjar;
	
	public Class[] loadGames( File dir ) throws IOException, ClassNotFoundException{
		
		myName.addLast( dir.getName() );
	
		LinkedList<Class> allGames = new LinkedList<Class>();
		File[] allfiles = dir.listFiles();
		Class[] result = new Class[1];
		
		for( File f: allfiles ){
			if( f.isDirectory() ){
				Class[] nextGames = loadGames(f);
				for( Class c: nextGames ){
					allGames.add(c);
				}				
			}
		}
		// all directory have been seen
		for( File f: allfiles ){
			if(  f.getName().endsWith( ".class" )){
				
				String name = "org.lantsovanton";
				name += ".";
				for( String t: myName ){
					if(! t.equals("org") ){
						name += t + "."; 
					}
					
				}
				String temp = f.getName();				
				char[] tempchar = temp.toCharArray();
				for( char c: tempchar ){
					if( c == '.' ){
						break;
					}
					name += c;
				}
				
				
				Class<?> fclass = loadClass( name);
				resolveClass(fclass);
				Class[]  interfaces = fclass.getInterfaces();
				for( Class i : interfaces ){
					if( i.equals(IGame.class)  ){
						allGames.addLast(fclass);
					}
				}
				
			}
		}		
		myName.removeLast();
	
		if( allGames == null ){
			return null;
		}
		
		return allGames.toArray(result);
		
	}
	
    public Class[] loadGames() throws IOException, ClassNotFoundException{	
		
		LinkedList<Class> games = new LinkedList<Class>(); 
		
		JarFile jarfile = new JarFile( myjar );		
		Enumeration<JarEntry> enumeration = jarfile.entries();
        while( enumeration.hasMoreElements() ){
        	String name ="";        	
        	JarEntry entry = enumeration.nextElement();
        	if( entry.getName().endsWith(".class") ){
        		char[] arrayName = entry.getName().toCharArray();
        		for( int i = 0; i < arrayName.length - 6; i++ ){
        			if( arrayName[i] != '/'  ){
        				name += arrayName[i];
        			}else{
        				name += '.';  
        			}
        			
        		}
        		Class nextClass = loadClass( name  );
        		resolveClass(nextClass);
        		
        		Class[]  interfaces = nextClass.getInterfaces();
				for( Class i : interfaces ){
					if( i.equals(IGame.class)  ){
						games.addLast(nextClass);
					}
				}
        	  		
        	}
        }
        Class[] result = new Class[1];

        return  games.toArray(result);

	}
    
    public Class[] loadGamesClasses() throws IOException, ClassNotFoundException{ 
    	URL gamesURL = GameLoader.class.getResource("/org/lantsovanton/games/GameLoader.class"); 

		File dirofgames = new File( gamesURL.getFile() );
		// jar 
		if(  !  dirofgames.getParentFile().exists() ){
            URL url = GameLoader.class.getResource("/org/lantsovanton/games/GameLoader.class");
	    	String fileName = url.toString();
	    	fileName = URLDecoder.decode(fileName, "UTF-8" );
	    	if (fileName.startsWith("jar:file:")) {
                fileName = fileName.substring(9);
	    	}
	    	int indexOfExclamation = fileName.indexOf('!');
	    	if (indexOfExclamation >= 0) {
	 	    	fileName = fileName.substring(0, indexOfExclamation);
	    	}
	    	myjar = fileName;
	    	System.out.println( myjar );
			return loadGames();

		}

		return loadGames( dirofgames.getParentFile() );
		
    	
    }

}
