package org.lantsovanton.games.attax;


import java.util.LinkedList;
import java.util.Random;


import org.lantsovanton.abstraction.model.IGame;
import org.lantsovanton.abstraction.model.IMove;
import org.lantsovanton.abstraction.model.IPosition;
import org.lantsovanton.abstraction.model.Intellect;
import org.lantsovanton.movers.AttaxMove;


public class RandomAttax implements Intellect {
	private IGame myGame;
	private String myName = "RandomAttax";
	private IPosition myPosition;
	private int myPlayer;
    private boolean myPermit = true;
	private LinkedList<IMove> myMoves = new LinkedList<IMove>();
    
	public String getName() {
		
		return myName;
	}

	public IGame getGame() {
		
		return myGame;
	}

	public int getPlayer() {
		return myPlayer;
	}

	public IPosition getPosition() {		
		return myPosition;
	}

	public IMove go() {
		//
		AttaxMove move = new AttaxMove( myPlayer );
		move.add( 7, 0 );
		move.add( 7, 1 );
		if( myGame.isMovePosible(myPosition,move) ){
			//return move;
		}
		if( ! myPermit ){
			for( int h = 0; h < 8; h++ ){
				for( int l = 0; l < 8; l++ ){
					
					if( myPosition.get(h,l) != null ){
						if( myPosition.get(h,l).getPlayer() == myPlayer ){
							for ( int htemp = h - 2; htemp < h + 3; htemp++ ){
								for( int ltemp = l -2; ltemp < l + 3; ltemp++ ){
									
									if( htemp >= 0 && htemp < 8 && ltemp >= 0 && ltemp < 8 ){
										if( myPosition.get( htemp, ltemp ) == null ){
											move = new AttaxMove( myPlayer );
											move.add( l, h );
											move.add( ltemp, htemp );
											return move;
										}
									}
								}
							}
						}
					}
					
				}
			}
		}else{
			for( int h = 0; h < 8; h++ ){
				for( int l = 0; l < 8; l++ ){
					
					if( myPosition.get(h,l) != null ){
						if( myPosition.get(h,l).getPlayer() == myPlayer ){
							for ( int htemp = h - 2; htemp < h + 3; htemp++ ){
								for( int ltemp = l -2; ltemp < l + 3; ltemp++ ){
									
									if( htemp >= 0 && htemp < 8 && ltemp >= 0 && ltemp < 8 ){
										if( myPosition.get( htemp, ltemp ) == null ){
											move = new AttaxMove( myPlayer );
											move.add( l, h );
											move.add( ltemp, htemp );
											myMoves.addLast(move);
										}
									}
								}
							}
						}
					}
					
				}
			}
			Random random = new Random();
			int n = random.nextInt( myMoves.size() );
			IMove resultMove = myMoves.get(n);
			int good = -30;
			
			for( IMove m: myMoves ){
				if( this.goodPosition( myGame.tryMove(myPosition,m) ) > good || this.goodPosition( myGame.tryMove(myPosition,m) )== good && random.nextBoolean()){
					good = this.goodPosition( myGame.tryMove(myPosition,m) );
					resultMove = m;				
				}
			}
			
					
			myMoves = new LinkedList<IMove>();
			return resultMove;
		
		}
		
		return null;
	}
	
	private int goodPosition( IPosition position ){
		int bad = 0;
		int good = 0;
		for( int h = 0; h < 8; h++ ){
			for( int  l = 0; l < 8; l++ ){
				if( position.get( h, l ) != null ){
					if( position.get( h, l ).getPlayer() == myPlayer ){
						good++;
					}else{
						bad++;
					}
				}
			}
		}
		return good - bad;
	}
 
	 
	public void setGame(IGame game) {
		myGame = game;

	}

	public void setPosition(IPosition position) {
		myPosition = position;
	
	}

	public void setPlayer(int player) {
		myPlayer = player;

	}

	public void setRandom( boolean permit ) {
		myPermit = permit;
	}

}
